"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const __1 = require("..");
function useQuery(name, args, opts) {
    const collection = (0, __1.useCollection)({ liveUpdates: true });
    const state = (0, __1.useAsync)(async (collection, name, args, opts) => {
        if (!collection)
            return null;
        const res = await collection.query(name, args, opts);
        return res;
    }, [collection, name, args, opts], [collection, name, JSON.stringify({ args, opts })]);
    const lseq = collection && collection.length;
    react_1.default.useEffect(() => {
        state.refresh();
    }, [lseq]);
    state.records = state.data;
    return state;
}
exports.default = useQuery;
//# sourceMappingURL=use-query.js.map