"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useRecords = void 0;
const react_1 = __importDefault(require("react"));
const __1 = require("..");
function useRecords(props = {}) {
    props.single = false;
    return useRecord(props);
}
exports.useRecords = useRecords;
function useRecord(props = {}) {
    let { path, type, id, update, single = true } = props;
    if (path) {
        const parts = path.split('/');
        id = parts.pop();
        type = parts.join('/');
    }
    else {
        path = type + '/' + id;
    }
    const collection = (0, __1.useCollection)();
    const [_updateCounter, setUpdateCounter] = react_1.default.useState(0);
    const state = (0, __1.useAsync)(async (collection, path, update, single) => {
        if (!collection)
            return null;
        if (!id || !type)
            return null;
        let record;
        if (!update && single) {
            record = collection.store.getRecord(path);
        }
        if (!record) {
            record = await collection.get({ type, id });
            if (!record.length)
                return null;
            if (single)
                record = record[0];
        }
        return record;
    }, [collection, path, !!update, single]);
    const record = state.data;
    // if (state.data && state.data.length) record = state.data[0]
    react_1.default.useEffect(() => {
        if (!record || !single)
            return;
        return record.subscribe(() => {
            setUpdateCounter(updateCounter => updateCounter + 1);
        });
    }, [record]);
    return record;
    // if (!record || !record.length) return null
    // return record[0]
    // console.log('useRecord', path, record)
    // if (!record.length) return null
}
exports.default = useRecord;
//# sourceMappingURL=use-record.js.map