"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useWorkspace = exports.WorkspaceProvider = exports.workspaces = void 0;
const react_1 = __importStar(require("react"));
const use_config_1 = __importDefault(require("./use-config"));
const client_1 = require("@arsonar/client");
exports.workspaces = new Map();
if (typeof window !== 'undefined') {
    window.arsonarWorkspaces = exports.workspaces;
}
const Context = react_1.default.createContext(null);
function WorkspaceProvider(props = {}) {
    if (props.appId)
        props.name = props.appId;
    const [config, setConfig] = (0, use_config_1.default)(props.appId, props.config);
    const context = (0, react_1.useMemo)(() => ({
        workspace: workspaceFromConfig(config),
        config,
        setConfig,
        defaultCollection: props.collection || config.collection || null
    }), [config]);
    window.__sonarContext = context;
    return react_1.default.createElement(Context.Provider, { value: context }, props.children);
}
exports.WorkspaceProvider = WorkspaceProvider;
function useWorkspace() {
    return react_1.default.useContext(Context);
}
exports.useWorkspace = useWorkspace;
function workspaceFromConfig(config) {
    const base = config.url || config.endpoint + config.workspace;
    const key = JSON.stringify([base, config.token || config.accessCode]);
    if (!exports.workspaces.has(key)) {
        exports.workspaces.set(key, new client_1.Workspace(config));
    }
    return exports.workspaces.get(key);
}
//# sourceMappingURL=use-workspace.js.map