import type { PropsWithChildren } from 'react';
import type { AsyncState } from './use-async';
import type { Collection, Workspace } from '@arsonar/client';
export declare type MaybeCollection = null | Collection;
export declare type CollectionContextProps = PropsWithChildren<{
    collection?: Collection;
}>;
export declare type CollectionContext = {
    collection?: Collection;
};
export declare type AsyncCollectionState = AsyncState<Collection> & {
    collection: MaybeCollection;
    updated: number;
};
export declare function CollectionContext(props?: CollectionContextProps): JSX.Element;
export declare type UseCollectionOpts = {
    state?: boolean;
    collection?: string;
    liveUpdates?: boolean;
};
export declare function useCollection(opts?: UseCollectionOpts): MaybeCollection;
export declare function useCollectionState(opts?: UseCollectionOpts): AsyncCollectionState;
export declare function useCollectionInner(workspace: Workspace, collectionName?: string, opts?: UseCollectionOpts): AsyncCollectionState;
//# sourceMappingURL=use-collection.d.ts.map